import{s as ke,n as Oe,o as Le}from"../chunks/scheduler.8c3d61f6.js";import{S as Ee,i as He,g as a,s as n,r as u,A as Ie,h as d,f as t,c as i,j as M,u as p,x as v,k as P,y as r,a as c,v as m,d as f,t as h,w as g}from"../chunks/index.da70eac4.js";import{D as G}from"../chunks/Docstring.6b390b9a.js";import{H as $e,E as qe}from"../chunks/EditOnGithub.1e64e623.js";function ze(xe){let _,j,W,Y,T,J,A,Se='The <code>KDPM2DiscreteScheduler</code> with ancestral sampling is inspired by the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of Diffusion-Based Generative Models</a> paper, and the scheduler is ported from and created by <a href="https://github.com/crowsonkb/" rel="nofollow">Katherine Crowson</a>.',Q,w,Me='The original codebase can be found at <a href="https://github.com/crowsonkb/k-diffusion" rel="nofollow">crowsonkb/k-diffusion</a>.',X,y,Z,o,K,le,q,Pe=`KDPM2DiscreteScheduler with ancestral sampling is inspired by the DPMSolver2 and Algorithm 2 from the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating
the Design Space of Diffusion-Based Generative Models</a> paper.`,ue,z,Te=`This model inherits from <a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/main/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,pe,D,C,me,F,Ae=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,fe,$,k,he,N,we="Sets the begin index for the scheduler. This function should be run from pipeline before the inference.",ge,x,O,_e,U,ye="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",be,S,L,ve,V,Ke=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the diffusion
process from the learned model outputs (most often the predicted noise).`,ee,E,te,b,H,De,B,Ce="Base class for the output of a scheduler’s <code>step</code> function.",se,I,re,R,ne;return T=new $e({props:{title:"KDPM2AncestralDiscreteScheduler",local:"kdpm2ancestraldiscretescheduler",headingTag:"h1"}}),y=new $e({props:{title:"KDPM2AncestralDiscreteScheduler",local:"diffusers.KDPM2AncestralDiscreteScheduler",headingTag:"h2"}}),K=new G({props:{name:"class diffusers.KDPM2AncestralDiscreteScheduler",anchor:"diffusers.KDPM2AncestralDiscreteScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.00085"},{name:"beta_end",val:": float = 0.012"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": Union = None"},{name:"use_karras_sigmas",val:": Optional = False"},{name:"use_exponential_sigmas",val:": Optional = False"},{name:"use_beta_sigmas",val:": Optional = False"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"timestep_spacing",val:": str = 'linspace'"},{name:"steps_offset",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.00085) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.012) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code> or <code>scaled_linear</code>.`,name:"beta_schedule"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.use_karras_sigmas",description:`<strong>use_karras_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use Karras sigmas for step sizes in the noise schedule during the sampling process. If <code>True</code>,
the sigmas are determined according to a sequence of noise levels {&#x3C3;i}.`,name:"use_karras_sigmas"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.use_exponential_sigmas",description:`<strong>use_exponential_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use exponential sigmas for step sizes in the noise schedule during the sampling process.`,name:"use_exponential_sigmas"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.use_beta_sigmas",description:`<strong>use_beta_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use beta sigmas for step sizes in the noise schedule during the sampling process. Refer to <a href="https://huggingface.co/papers/2407.12173" rel="nofollow">Beta
Sampling is All You Need</a> for more information.`,name:"use_beta_sigmas"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;linspace&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps, as required by some model families.`,name:"steps_offset"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_k_dpm_2_ancestral_discrete.py#L76"}}),C=new G({props:{name:"scale_model_input",anchor:"diffusers.KDPM2AncestralDiscreteScheduler.scale_model_input",parameters:[{name:"sample",val:": Tensor"},{name:"timestep",val:": Union"}],parametersDescription:[{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
The input sample.`,name:"sample"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.scale_model_input.timestep",description:`<strong>timestep</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The current timestep in the diffusion chain.`,name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_k_dpm_2_ancestral_discrete.py#L194",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A scaled input sample.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),k=new G({props:{name:"set_begin_index",anchor:"diffusers.KDPM2AncestralDiscreteScheduler.set_begin_index",parameters:[{name:"begin_index",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.set_begin_index.begin_index",description:`<strong>begin_index</strong> (<code>int</code>) &#x2014;
The begin index for the scheduler.`,name:"begin_index"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_k_dpm_2_ancestral_discrete.py#L184"}}),O=new G({props:{name:"set_timesteps",anchor:"diffusers.KDPM2AncestralDiscreteScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": int"},{name:"device",val:": Union = None"},{name:"num_train_timesteps",val:": Optional = None"}],parametersDescription:[{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_k_dpm_2_ancestral_discrete.py#L224"}}),L=new G({props:{name:"step",anchor:"diffusers.KDPM2AncestralDiscreteScheduler.step",parameters:[{name:"model_output",val:": Union"},{name:"timestep",val:": Union"},{name:"sample",val:": Union"},{name:"generator",val:": Optional = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.Tensor</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.step.timestep",description:`<strong>timestep</strong> (<code>float</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.step.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
A random number generator.`,name:"generator"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/schedulers/multistep_dpm_solver_inverse#diffusers.schedulers.scheduling_utils.SchedulerOutput">SchedulerOutput</a> or tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_k_dpm_2_ancestral_discrete.py#L455",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>If return_dict is <code>True</code>, <code>~schedulers.scheduling_ddim.SchedulerOutput</code> is returned, otherwise a
tuple is returned where the first element is the sample tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><a
  href="/docs/diffusers/main/en/api/schedulers/multistep_dpm_solver_inverse#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> or <code>tuple</code></p>
`}}),E=new $e({props:{title:"SchedulerOutput",local:"diffusers.schedulers.scheduling_utils.SchedulerOutput",headingTag:"h2"}}),H=new G({props:{name:"class diffusers.schedulers.scheduling_utils.SchedulerOutput",anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput",parameters:[{name:"prev_sample",val:": Tensor"}],parametersDescription:[{anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput.prev_sample",description:`<strong>prev_sample</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
Computed sample <code>(x_{t-1})</code> of previous timestep. <code>prev_sample</code> should be used as next model input in the
denoising loop.`,name:"prev_sample"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_utils.py#L60"}}),I=new qe({props:{source:"https://github.com/huggingface/diffusers/blob/main/docs/source/en/api/schedulers/dpm_discrete_ancestral.md"}}),{c(){_=a("meta"),j=n(),W=a("p"),Y=n(),u(T.$$.fragment),J=n(),A=a("p"),A.innerHTML=Se,Q=n(),w=a("p"),w.innerHTML=Me,X=n(),u(y.$$.fragment),Z=n(),o=a("div"),u(K.$$.fragment),le=n(),q=a("p"),q.innerHTML=Pe,ue=n(),z=a("p"),z.innerHTML=Te,pe=n(),D=a("div"),u(C.$$.fragment),me=n(),F=a("p"),F.textContent=Ae,fe=n(),$=a("div"),u(k.$$.fragment),he=n(),N=a("p"),N.textContent=we,ge=n(),x=a("div"),u(O.$$.fragment),_e=n(),U=a("p"),U.textContent=ye,be=n(),S=a("div"),u(L.$$.fragment),ve=n(),V=a("p"),V.textContent=Ke,ee=n(),u(E.$$.fragment),te=n(),b=a("div"),u(H.$$.fragment),De=n(),B=a("p"),B.innerHTML=Ce,se=n(),u(I.$$.fragment),re=n(),R=a("p"),this.h()},l(e){const s=Ie("svelte-u9bgzb",document.head);_=d(s,"META",{name:!0,content:!0}),s.forEach(t),j=i(e),W=d(e,"P",{}),M(W).forEach(t),Y=i(e),p(T.$$.fragment,e),J=i(e),A=d(e,"P",{"data-svelte-h":!0}),v(A)!=="svelte-1xsfzct"&&(A.innerHTML=Se),Q=i(e),w=d(e,"P",{"data-svelte-h":!0}),v(w)!=="svelte-loovl7"&&(w.innerHTML=Me),X=i(e),p(y.$$.fragment,e),Z=i(e),o=d(e,"DIV",{class:!0});var l=M(o);p(K.$$.fragment,l),le=i(l),q=d(l,"P",{"data-svelte-h":!0}),v(q)!=="svelte-lafslh"&&(q.innerHTML=Pe),ue=i(l),z=d(l,"P",{"data-svelte-h":!0}),v(z)!=="svelte-linuuh"&&(z.innerHTML=Te),pe=i(l),D=d(l,"DIV",{class:!0});var ie=M(D);p(C.$$.fragment,ie),me=i(ie),F=d(ie,"P",{"data-svelte-h":!0}),v(F)!=="svelte-1rkfgpx"&&(F.textContent=Ae),ie.forEach(t),fe=i(l),$=d(l,"DIV",{class:!0});var oe=M($);p(k.$$.fragment,oe),he=i(oe),N=d(oe,"P",{"data-svelte-h":!0}),v(N)!=="svelte-1k141rk"&&(N.textContent=we),oe.forEach(t),ge=i(l),x=d(l,"DIV",{class:!0});var ae=M(x);p(O.$$.fragment,ae),_e=i(ae),U=d(ae,"P",{"data-svelte-h":!0}),v(U)!=="svelte-1vzm9q"&&(U.textContent=ye),ae.forEach(t),be=i(l),S=d(l,"DIV",{class:!0});var de=M(S);p(L.$$.fragment,de),ve=i(de),V=d(de,"P",{"data-svelte-h":!0}),v(V)!=="svelte-hi84tp"&&(V.textContent=Ke),de.forEach(t),l.forEach(t),ee=i(e),p(E.$$.fragment,e),te=i(e),b=d(e,"DIV",{class:!0});var ce=M(b);p(H.$$.fragment,ce),De=i(ce),B=d(ce,"P",{"data-svelte-h":!0}),v(B)!=="svelte-6ojmkw"&&(B.innerHTML=Ce),ce.forEach(t),se=i(e),p(I.$$.fragment,e),re=i(e),R=d(e,"P",{}),M(R).forEach(t),this.h()},h(){P(_,"name","hf:doc:metadata"),P(_,"content",Fe),P(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),P($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),P(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),P(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),P(o,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),P(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,s){r(document.head,_),c(e,j,s),c(e,W,s),c(e,Y,s),m(T,e,s),c(e,J,s),c(e,A,s),c(e,Q,s),c(e,w,s),c(e,X,s),m(y,e,s),c(e,Z,s),c(e,o,s),m(K,o,null),r(o,le),r(o,q),r(o,ue),r(o,z),r(o,pe),r(o,D),m(C,D,null),r(D,me),r(D,F),r(o,fe),r(o,$),m(k,$,null),r($,he),r($,N),r(o,ge),r(o,x),m(O,x,null),r(x,_e),r(x,U),r(o,be),r(o,S),m(L,S,null),r(S,ve),r(S,V),c(e,ee,s),m(E,e,s),c(e,te,s),c(e,b,s),m(H,b,null),r(b,De),r(b,B),c(e,se,s),m(I,e,s),c(e,re,s),c(e,R,s),ne=!0},p:Oe,i(e){ne||(f(T.$$.fragment,e),f(y.$$.fragment,e),f(K.$$.fragment,e),f(C.$$.fragment,e),f(k.$$.fragment,e),f(O.$$.fragment,e),f(L.$$.fragment,e),f(E.$$.fragment,e),f(H.$$.fragment,e),f(I.$$.fragment,e),ne=!0)},o(e){h(T.$$.fragment,e),h(y.$$.fragment,e),h(K.$$.fragment,e),h(C.$$.fragment,e),h(k.$$.fragment,e),h(O.$$.fragment,e),h(L.$$.fragment,e),h(E.$$.fragment,e),h(H.$$.fragment,e),h(I.$$.fragment,e),ne=!1},d(e){e&&(t(j),t(W),t(Y),t(J),t(A),t(Q),t(w),t(X),t(Z),t(o),t(ee),t(te),t(b),t(se),t(re),t(R)),t(_),g(T,e),g(y,e),g(K),g(C),g(k),g(O),g(L),g(E,e),g(H),g(I,e)}}}const Fe='{"title":"KDPM2AncestralDiscreteScheduler","local":"kdpm2ancestraldiscretescheduler","sections":[{"title":"KDPM2AncestralDiscreteScheduler","local":"diffusers.KDPM2AncestralDiscreteScheduler","sections":[],"depth":2},{"title":"SchedulerOutput","local":"diffusers.schedulers.scheduling_utils.SchedulerOutput","sections":[],"depth":2}],"depth":1}';function Ne(xe){return Le(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class We extends Ee{constructor(_){super(),He(this,_,Ne,ze,ke,{})}}export{We as component};
